import React, { Component } from 'react';
import {Sensor,Data} from './model.js' 
import { Link } from 'react-router-dom';
import mqtt from 'mqtt';
import {BrowserRouter as Router,Route, Redirect} from 'react-router-dom'
import './App.css';


/***********************************************************************************************************************/

/*** Composants class for displaying sensors, their types and values***/
class Composants extends React.Component
{
	
	
	render(){

		
		
         //Get the last values of a captor
        let lastValues = this.props.capteur.data.values.slice(Math.max(this.props.capteur.data.values.length - 6, 1))
        var latestValue;
        
        //Get Values
        const values = lastValues.map(function(v)
        {
            if (Number(v)){
                return  <tr><td class="tdValues">{Number(v).toFixed(3)} </td></tr>
            }else{
                return  <tr><td class="tdValues">{v} </td></tr>
            }
    
        });
         

    //Get the latest value

        
	
		if (Number(this.props.capteur.data.getlastValues())){
			latestValue = parseFloat(this.props.capteur.data.getlastValues()).toFixed(3);
		}else{
			latestValue = this.props.capteur.data.getlastValues();
		}	

      
        if(this.props.capteur.type === "TEMPERATURE"){
            latestValue += " °";
        }else if(this.props.capteur.type === "PERCENT"){
            latestValue += " %";
        }else if(this.props.capteur.type === "ON_OFF"){
            latestValue += " (ON/OFF)";
        }


    
        // Display of values and the last value 
				return (
			<div>
					<h1> {this.props.capteur.name+ "            " + "Type:"+this.props.capteur.type+""}</h1>
					<div>
						<div>
							<h2>Valeur actuelle : {latestValue}</h2>
							 
							
						</div>
					</div>
                    <div>

                   <h3> Historique : </h3>
                  {values}
  
                    </div>  
			</div>
			
		);
	}
}
/*********************************************************************************************************/
/***Sensors Class for displaying all sensors .****/

class Sensors extends React.Component{
  render(){
      
      const values1= <li>
                      <Link to={`/temperatureChambre`}><button type='button'>TemperatureChambre</button></Link></li>
      const values2= <li>
                      <Link to={`/MesYeux`}><button type='button'>MesYeux</button></Link></li>
       const values3= <li>
                      <Link to={`/temperatureSalleA111`}><button type='button'>temperatureSalleA111</button></Link></li>
       const values4= <li>
                      <Link to={`/MonAttention`}><button type='button'>MonAttention</button></Link></li>
                              
                          
                      
                      
                  
      
      return (
          <ul>
          {values1}
          {values2}
          {values3}
          {values4}
          </ul>
      );
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// connexion au serveur mqtt
var user_mqtt = mqtt.connect('mqtt://127.0.0.1:8080')


user_mqtt.on('connect', function () {
    user_mqtt.subscribe('#')
})

// List of Sensors
let SensorsList= [];

// Get sonsors into a list
function ListSensors(name, list){
 var i;
  for (i = 0; i < list.length; i++) {
      if (list[i].name === name) {
          return list[i];
      }
  }
}

class App extends Component {
  constructor(props) {

    super(props); 
    this.sensor = null;
    this.state = {value: '',list: []};
    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.rendom_app_sensor();
  }

  handleChange(event) {
    this.setState({value: "/"+event.target.value});
  }
  
  handleSubmit(event) {
    return <Redirect to="" />;    
  }
  //Get Random sensors
   rendom_app_sensor(){
    let resultList = this;
    user_mqtt.on('message', function (topic, message) { 
               
        var Json = JSON.parse(message.toString());
        // Sensor information name type and value
        var SensorName = topic.substring(6);
        var SensorValue = Json['value'];        
        var SensorType = Json['type'] 
      
        var data = new Data([SensorValue]);//  Data instance 
        var Sen= new Sensor(SensorName,SensorType,data);// Sensor instance
                  
          SensorsList.push(Sen);// insert sensor in the list
              
          Sen=ListSensors(SensorName,SensorsList);
     

     //insert a value in the table
          Array.prototype.push.apply(Sen.data.values, [SensorValue]);
                
          resultList.setState({list:SensorsList});
      });
  }


  // Get state 
  State(name)
  {
    
    var i;
    for (i = 0; i < this.state.list.length; i++)
     {
        if (this.state.list[i].name === name) {
            return this.state.list[i];
        }
    }
  }


  render() {
    return (
        //Add routes
      <Router>

      <div>

        
          <header><center>
            <form onSubmit={this.handleSubmit} action={this.state.value}> 
               url du Broker :
                <input type="text" onChange={this.handleChange}/>
                <input type="submit" value="Valider" />
            </form> 
            </center>
          </header>
          
          <div className="wrapper">
            <nav>
                <Sensors list={this.state.list}/>
            </nav>

            <article>
              <Route path="/:nameSensor" render={(props) => {return <Composants capteur={this.State(props.match.params.nameSensor)} /> }} />
            </article>
            
          </div>
          <footer>

          </footer>
        
       </div>
       </Router>
       
    );
  }
 
}

export default App;
